"use strict";function shuffle(t){if(!isArray(t))throw new Error("Utilities.shuffle() -> Invalid 'array' argument. Not an array.");for(var e,i,r=t.length;0!==r;)i=Math.floor(Math.random()*r),e=t[--r],t[r]=t[i],t[i]=e;return t}function boxBoxCollision(t,e,i,r,n,o,s,a){return!(e+r<o||e>o+a||t>n+s||t+i<n)}function circleCircleCollision(t,e,i,r,n,o){var s=t-r,a=e-n;return Math.pow(s,2)+Math.pow(a,2)<=Math.pow(i+o,2)}function circlePointCollision(t,e,i,r,n){var o=t-r,s=e-n;return o*o+s*s<=i*i}function pointBoxCollision(t,e,i,r,n,o){return!(t<i||t>i+n||e<r||e>r+o)}Object.defineProperty(exports,"__esModule",{value:!0});var KEY_CODE={backspace:8,tab:9,enter:13,esc:27,space:32,end:35,home:36,leftArrow:37,upArrow:38,rightArrow:39,downArrow:40,del:46,0:48,1:49,2:50,3:51,4:52,5:53,6:54,7:55,8:56,9:57,a:65,b:66,c:67,d:68,e:69,f:70,g:71,h:72,i:73,j:74,k:75,l:76,m:77,n:78,o:79,p:80,q:81,r:82,s:83,t:84,u:85,v:86,w:87,x:88,y:89,z:90,f1:112,f2:113,f3:114,f4:115,f5:116,f6:117,f7:118,f8:119,f9:120,f10:121,f11:122,f12:123},MOUSE_CODE={left:0,middle:1,right:2};function getObject(t){if(!isString(t))throw new Error("Utilities.getObject() -> Invalid 'key' argument. Not a string.");var e=localStorage.getItem(t);return e&&JSON.parse(e)}function saveObject(t,e){if(!isString(t))throw new Error("Utilities.saveObject() -> Invalid 'key' argument. Not a string.");localStorage.setItem(t,JSON.stringify(e))}function isArray(t){return"[object Array]"===Object.prototype.toString.call(t)}function isBoolean(t){return!0===t||!1===t||"[object Boolean]"===Object.prototype.toString.call(t)}function isFunction(t){return"function"==typeof t&&"[object Function]"===Object.prototype.toString.call(t)}function isInteger(t){return isNumber(t)&&t%1==0}function isNumber(t){return"number"==typeof t&&!isNaN(parseFloat(t))&&isFinite(t)}function isString(t){return"string"==typeof t||t instanceof String}function getRandomFloat(t,e){if(!isNumber(t)||!isNumber(e)||t>e)throw new Error("Utilities.getRandomFloat() -> Invalid arguments. Either 'min'/'max' are not numbers, or 'min' > 'max'.");return Math.random()*(e-t)+t}function getRandomInt(t,e){if(!isInteger(t)||!isInteger(e)||t>e)throw new Error("Utilities.getRandomInt() -> Invalid arguments. Either 'min'/'max' are not integers, or 'min > 'max'.");return Math.floor(Math.random()*(e-t+1))+t}function getSeveralRandomInts(t,e,i){if(!isInteger(t)||!isInteger(e)||!isInteger(i)||t>e||e-t<i-1)throw new Error("Utilities.getSeveralRandomInts() -> Invalid arguments.");for(var r=[];r.length<i;){var n=getRandomInt(t,e);r.indexOf(n)<0&&r.push(n)}return r}function numberOfDigits(t){if(!isNumber(t))throw new Error("Utilities.numberOfDigits() -> Invalid 'theNumber' argument. Not a number.");return t<0&&(t*=-1),t.toString().replace(".","").length}function round(t,e){if(!isNumber(t)||!isInteger(e)||e<0)throw new Error("Utilities.round() -> Invalid arguments.");return Math.round(t*Math.pow(10,e))/Math.pow(10,e)}function deepClone(t){return JSON.parse(JSON.stringify(t))}function createEnum(t,e){if(!isArray(t))throw new Error("Utilities.createEnum() -> Invalid 'values' argument. Needs to be an array of strings.");isNumber(e)||(e=0);for(var i={},r=t.length,n=0;n<r;n++){let r=t[n];i[e]=r,i[r]=e,e+=1}return i}function timeToString(t,e=2){if(!isNumber(t))throw new Error("Utilities.timeToString() -> Invalid 'dateMilliseconds' argument. Not a number.");isNumber(e)||(e=2);for(var i=0,r=0,n=0;t>=864e5;)n++,t-=864e5;for(;t>=36e5;)r++,t-=36e5;for(;t>=6e4;)i++,t-=6e4;var o,s,a,l=[{name:"day",time:n},{name:"hour",time:r},{name:"minute",time:i},{name:"second",time:round(t/1e3,2)}],u="";for(o=0;o<l.length&&0!==e;o++){let t=l[o];0!==t.time&&(""!==u&&(u+=" "),u+=(s=t.name,1!==(a=t.time)&&(s+="s"),a+" "+s),e--)}return""===u&&(u="0 seconds"),u}class Timeout{constructor(){this.is_active=!1,this.id=-1}start(t,e){if(!isFunction(t)||!isNumber(e))throw new Error("Utilities.Timeout.start() -> Invalid arguments.");this.is_active&&this.clear(),this.is_active=!0,this.id=window.setTimeout(()=>{this.is_active=!1,t()},e)}clear(){window.clearTimeout(this.id),this.is_active=!1}isActive(){return this.is_active}}class Timer{constructor(t){if(void 0!==t&&!(t instanceof HTMLElement))throw new Error("Utilities.Timer() -> Invalid 'htmlElement' argument. Not an HTML element.");this.is_active=!1,this.start_value=0,this.count_down=!1,this.time_count=0,this.html_element=t,this.updateHtmlElement()}start(t){void 0===t&&(t={}),isNumber(t.startValue)||(t.startValue=0),isNumber(t.endValue)||(t.endValue=void 0),isFunction(t.onEnd)||(t.onEnd=void 0),isFunction(t.onTick)||(t.onTick=void 0),!0!==t.countDown&&(t.countDown=!1),this.is_active&&this.stop(),this.count_down=t.countDown,this.time_count=t.startValue,this.start_value=t.startValue,this.end_value=t.endValue,this.end_callback=t.onEnd,this.tick_callback=t.onTick,this.updateHtmlElement(),this.resume()}resume(){if(!this.is_active){var t=this;this.is_active=!0,this.interval_f=window.setInterval(function(){if(t.count_down?t.time_count-=1e3:t.time_count+=1e3,void 0!==t.end_value){var e=!1;t.count_down?t.time_count<=t.end_value&&(e=!0):t.time_count>=t.end_value&&(e=!0),e&&(t.stop(),void 0!==t.end_callback&&t.end_callback())}void 0!==t.tick_callback&&t.tick_callback(),t.updateHtmlElement()},1e3)}}stop(){this.interval_f&&(window.clearInterval(this.interval_f),this.interval_f=void 0),this.is_active=!1}reset(){this.stop(),this.time_count=this.start_value,this.updateHtmlElement()}restart(){this.reset(),this.start({startValue:this.start_value,endValue:this.end_value,onEnd:this.end_callback,onTick:this.tick_callback,countDown:this.count_down})}updateHtmlElement(){this.html_element&&(this.html_element.innerHTML=this.getTimeString())}add(t){this.time_count+=t}getTimeString(){return timeToString(this.time_count)}getTimeSeconds(){return this.time_count/1e3}getTimeMilliseconds(){return this.time_count}}function calculateAngle(t,e,i,r){if(!(isNumber(t)&&isNumber(e)&&isNumber(i)&&isNumber(r)))throw new Error("Utilities.calculateAngle() -> Invalid arguments. Needs to be a number.");var n=e-r,o=i-t;return Math.atan2(n,o)}function calculateDistance(t,e,i,r){if(!(isNumber(t)&&isNumber(e)&&isNumber(i)&&isNumber(r)))throw new Error("Utilities.calculateDistance() -> Invalid arguments. Needs to be a number.");var n=r-e,o=i-t;return Math.sqrt(Math.pow(n,2)+Math.pow(o,2))}function toDegrees(t){if(!isNumber(t))throw new Error("Utilities.toDegrees() -> Invalid 'radians' argument. Not a number.");return 180*t/Math.PI}function toRadians(t){if(!isNumber(t))throw new Error("Utilities.toRadians() -> Invalid 'degrees' argument. Not a number.");return t*Math.PI/180}exports.KEY_CODE=KEY_CODE,exports.MOUSE_CODE=MOUSE_CODE,exports.Timeout=Timeout,exports.Timer=Timer,exports.boxBoxCollision=boxBoxCollision,exports.calculateAngle=calculateAngle,exports.calculateDistance=calculateDistance,exports.circleCircleCollision=circleCircleCollision,exports.circlePointCollision=circlePointCollision,exports.createEnum=createEnum,exports.deepClone=deepClone,exports.getObject=getObject,exports.getRandomFloat=getRandomFloat,exports.getRandomInt=getRandomInt,exports.getSeveralRandomInts=getSeveralRandomInts,exports.isArray=isArray,exports.isBoolean=isBoolean,exports.isFunction=isFunction,exports.isInteger=isInteger,exports.isNumber=isNumber,exports.isString=isString,exports.numberOfDigits=numberOfDigits,exports.pointBoxCollision=pointBoxCollision,exports.round=round,exports.saveObject=saveObject,exports.shuffle=shuffle,exports.timeToString=timeToString,exports.toDegrees=toDegrees,exports.toRadians=toRadians;
